//****************************************************************************
//	aisa08s.pas
//
//	aISA-P08
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/05/27
//
//	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
//
//****************************************************************************
unit aisa08s;

interface

uses
	Windows, Messages, SysUtils, Forms, aisa08w;

const
	szTitle = 'Sample';
	szName = 'aISA-R08';

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
	private
		procedure ResultMessage(strbuf: String);
		procedure ErrorMessage(wLogSlot: Word);
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
	strbuf:	 String;
	dwDLLVer, dwDrvVer: DWord;	// DLLCDrivero[W
	bResult:	Boolean;					// 
	wLogSlot: Word;							// foCXi[
	OutValue: Byte;							// o̓f[^
	ri:				TAISA08RESOURCE;	// \[X
begin
//---------------------------------------------------------------------------
	// aisa08.dll ̎gp錾
	if Aisa08wDllOpen() = False then
	begin
		ErrorMessage(AISA08_SLOT_AUTO);
		Exit;			// aisa08.dll ̃[hɎs܂
	end;

//---------------------------------------------------------------------------
	// o[Wԍ\
	// aISA-R08 DLL,Driver̃o[Wԍ擾
	if Aisa08wGetVersion(dwDLLVer, dwDrvVer) = False then
	begin
		ErrorMessage(AISA08_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('GetVersion'#10 +
					 'DLL Version: %08xH'#10 +
					 'Drv Version: %08xH',
										 [dwDLLVer, dwDrvVer]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aISA-R08̎gp錾
	wLogSlot := AISA08_SLOT_AUTO;				// gp̃foCXT܂B
	bResult := Aisa08wCreate(wLogSlot);	// ꍇA̎̃foCXi[܂B

	if bResult = False then		// foCX܂B
	begin
		ErrorMessage(AISA08_SLOT_AUTO);
		Exit;
	end;

	strbuf := Format('aISA-R08 Created'#10#10 +
									 'LogSlot: %2d', [wLogSlot]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// \[X擾
	if Aisa08wGetResource(wLogSlot, @ri) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Board Name: %s'#10 +
						 'NumPorts: %2d'#10 +
						 'IO Address: %04xH -%04xH'#10,
											[szName, ri.dwIOPortLength[1],
											ri.dwIOPortBase[1],
											ri.dwIOPortBase[1] + ri.dwIOPortLength[1] - 1]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// Port 0 ɔCӂ̃f[^o
	// o̓f[^ AAh
	OutValue := Byte($AA);

	if Aisa08wOutPort(wLogSlot, AISA08_PORT_0, OutValue) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	strbuf := Format('Port 0 փf[^o'#10 +
					 'Port 0 Out Data: %02xH',
					 [OutValue]);

	ResultMessage(strbuf);

//---------------------------------------------------------------------------
	// aISA-R08̎gpJ
	if Aisa08wClose(wLogSlot) = False then
	begin
		ErrorMessage(wLogSlot);
		Exit;
	end;

	ResultMessage('aISA-R08 Closed');

	// aisa08.dll ̎gpJ
	if Aisa08wDllClose() = False then
	begin
		Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
		Exit;			// aisa08.dll ̃A[hɎs܂B
	end;

end;

// ʂ\
procedure TForm1.ResultMessage(strbuf: String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;

// G[bZ[W\
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	strbuf: String;
begin
	dwRes := Aisa08wGetLastError(wLogSlot);

	case dwRes of
		AISA08_ERR_SYSTEM:
			strbuf := Format('System error'#10#10'Error code: %08xH', [GetLastError()]);

		AISA08_ERR_WRAPDLL:
			strbuf := 'DLL Load error';
	else
		strbuf := Format('aISA-R08 error'#10#10'Error code: %08xH',[dwRes]);
	end;

	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
